## edk2 0~20180803.dd4cae4d

=== BaseTools/Source/Python/Makefile ===
## @file
# Windows makefile for Python tools build.
#
# Copyright (c) 2010 - 2018, Intel Corporation. All rights reserved.<BR>
# This program and the accompanying materials
# are licensed and made available under the terms and conditions of the BSD License
# which accompanies this distribution.  The full text of the license may be found at
# http://opensource.org/licenses/bsd-license.php
#
# THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
# WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
#

!IFNDEF PYTHON_HOME
!ERROR PYTHON_HOME must be defined!
!ENDIF

!IFDEF PYTHON_FREEZER_PATH
!IF EXIST ($(PYTHON_FREEZER_PATH)\cxfreeze)
# Using cx_Freeze 4.2.3 with Python 2.7.2
FREEZE=$(PYTHON_HOME)\python $(PYTHON_FREEZER_PATH)\cxfreeze
!ELSE
!ERROR PYTHON_FREEZER_PATH does not exist!
!ENDIF
!ENDIF

MODULES=encodings.cp437,encodings.gbk,encodings.utf_16,encodings.utf_8,encodings.utf_16_le,encodings.latin_1,encodings.ascii

# DOS del command doesn't support ":\\" in the file path, such as j:\\BaseTools. Convert ":\\" to ":\"
BASE_TOOLS_PATH = $(BASE_TOOLS_PATH::\\=:\)
EDK_TOOLS_PATH  = $(EDK_TOOLS_PATH::\\=:\)

BIN_DIR=$(EDK_TOOLS_PATH)\Bin\Win32

APPLICATIONS=$(BIN_DIR)\build.exe $(BIN_DIR)\GenFds.exe $(BIN_DIR)\Trim.exe $(BIN_DIR)\TargetTool.exe $(BIN_DIR)\GenDepex.exe $(BIN_DIR)\GenPatchPcdTable.exe $(BIN_DIR)\PatchPcdValue.exe $(BIN_DIR)\BPDG.exe $(BIN_DIR)\UPT.exe $(BIN_DIR)\Rsa2048Sha256Sign.exe $(BIN_DIR)\Rsa2048Sha256GenerateKeys.exe $(BIN_DIR)\Pkcs7Sign.exe $(BIN_DIR)\Ecc.exe

COMMON_PYTHON=$(BASE_TOOLS_PATH)\Source\Python\Common\BuildToolError.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\Database.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\DataType.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\EdkLogger.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\Expression.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\GlobalData.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\Identification.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\LongFilePathOs.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\LongFilePathOsPath.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\LongFilePathSupport.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\Misc.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\Parsing.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\StringUtils.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\TargetTxtClassObject.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\ToolDefClassObject.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\VpdInfoFile.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\BuildVersion.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\MultipleWorkspace.py \
              $(BASE_TOOLS_PATH)\Source\Python\CommonDataClass\CommonClass.py \
              $(BASE_TOOLS_PATH)\Source\Python\CommonDataClass\DataClass.py \
              $(BASE_TOOLS_PATH)\Source\Python\CommonDataClass\Exceptions.py \
              $(BASE_TOOLS_PATH)\Source\Python\CommonDataClass\FdfClass.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\Table.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableDataModel.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableDec.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableDsc.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableEotReport.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableFdf.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableFile.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableFunction.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableIdentifier.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableInf.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TablePcd.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableQuery.py \
              $(BASE_TOOLS_PATH)\Source\Python\Table\TableReport.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\BuildClassObject.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\MetaDataTable.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\MetaFileCommentParser.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\MetaFileParser.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\MetaFileTable.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\WorkspaceCommon.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\WorkspaceDatabase.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\DecBuildData.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\DscBuildData.py \
              $(BASE_TOOLS_PATH)\Source\Python\Workspace\InfBuildData.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\AutoGen.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\BuildEngine.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\GenC.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\GenDepex.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\GenMake.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\GenPcdDb.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\InfSectionParser.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\StrGather.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\UniClassObject.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\ValidCheckingInfoObject.py \
              $(BASE_TOOLS_PATH)\Source\Python\AutoGen\GenVar.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\RangeExpression.py \
              $(BASE_TOOLS_PATH)\Source\Python\Common\VariableAttributes.py

CMD_BUILD=$(BASE_TOOLS_PATH)\Source\Python\build\BuildReport.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenPatchPcdTable\GenPatchPcdTable.py \
    $(BASE_TOOLS_PATH)\Source\Python\PatchPcdValue\PatchPcdValue.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\c.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\CLexer.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\CodeFragment.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\CodeFragmentCollector.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\CParser.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\Database.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\EfiCompressor.pyd \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\Eot.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\EotGlobalData.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\EotToolError.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\FileProfile.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\InfParserLite.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\LzmaCompressor.pyd \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\Parser.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\ParserWarning.py \
    $(BASE_TOOLS_PATH)\Source\Python\Eot\Report.py

CMD_GENFDS=$(BASE_TOOLS_PATH)\Source\Python\GenFds\AprioriSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Attribute.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Capsule.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\CapsuleData.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\ComponentStatement.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\CompressSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\DataSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\DepexSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\EfiSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Fd.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\FdfParser.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Ffs.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\FfsFileStatement.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\FfsInfStatement.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Fv.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\FvImageSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\GenFds.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\GenFdsGlobalVariable.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\GuidSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\OptionRom.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\OptRomFileStatement.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\OptRomInfStatement.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Region.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Rule.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\RuleComplexFile.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\RuleSimpleFile.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Section.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\UiSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\VerSection.py \
    $(BASE_TOOLS_PATH)\Source\Python\GenFds\Vtf.py

CMD_BPDG=$(BASE_TOOLS_PATH)\Source\Python\BPDG\GenVpd.py \
    $(BASE_TOOLS_PATH)\Source\Python\BPDG\StringTable.py

CMD_UPT=$(BASE_TOOLS_PATH)\Source\Python\UPT\Core\DependencyRules.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Core\DistributionPackageClass.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Core\FileHook.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Core\IpiDb.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Core\PackageFile.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Dll\sqlite3.dll \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\GenMetaFile\GenDecFile.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\GenMetaFile\GenInfFile.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\GenMetaFile\GenMetaFileMisc.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\GenMetaFile\GenXmlFile.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\InstallPkg.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\InventoryWs.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\CommentGenerating.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\CommentParsing.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\DataType.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\ExpressionValidate.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\GlobalData.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\Misc.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\ParserValidate.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\Parsing.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\StringUtils.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\UniClassObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Library\Xml\XmlRoutines.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Logger\Log.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Logger\StringTable.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Logger\ToolError.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\MkPkg.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\DecObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfBinaryObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfBuildOptionObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfCommonObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfDefineCommonObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfDefineObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfDepexObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfGuidObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfHeaderObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfLibraryClassesObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfMisc.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfPackagesObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfPcdObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfPpiObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfProtocolObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfSoucesObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\Parser\InfUserExtensionObject.py \
    $(BASE_TOOLS_PATH)\Source\Python\UPT\Object\POM\CommonObject.py \

=== debian/changelog ===
edk2 (0~20180803.dd4cae4d-1ubuntu1) cosmic; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - debian/patches/enroll-default-keys.patch: Build EnrollDefaultKeys.efi to
      provide an automated way of injecting Microsoft signing keys in VMs that
      need them.
    - debian/control: add genisoimage, qemu-utils, qemu-system-x86, python3 to
      Build-Depends for the automatic key enrollment process.
    - debian/rules:
      - build a SecureBoot/SMM enabled variant of OVMF_CODE too.
      - build OVMF_VARS.ms.fd with embedded Microsoft keys from the binary
        EnrollDefaultKeys.efi
    - debian/ovmf.links: add OVMF_CODE.ms.fd.
    - debian/ovmf.install: install OVMF_VARS.ms.fd.

 -- dann frazier <dannf@ubuntu.com>  Tue, 14 Aug 2018 16:09:06 -0600

edk2 (0~20180803.dd4cae4d-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Point the Vcs-* links to the new location on salsa.
  * d/p/ShellPkg-dp-Correct-case-of-included-file.patch: Drop;
    now upstream.

 -- dann frazier <dannf@debian.org>  Fri, 03 Aug 2018 15:35:01 -0600

edk2 (0~20180626.e5735040-1) unstable; urgency=medium

  * New upstream release.
  * d/p/ShellPkg-dp-Correct-case-of-included-file.patch: Add; fixes FTBFS.
  * debian/control: Point the Vcs-* links to the edk2 project in my
    namespace on salsa until we identify a more permanent location.

 -- dann frazier <dannf@debian.org>  Tue, 26 Jun 2018 17:06:59 -0600

edk2 (0~20180503.ebafede9-1ubuntu1) cosmic; urgency=medium

  * debian/patches/enroll-default-keys.patch: Build EnrollDefaultKeys.efi to
    provide an automated way of injecting Microsoft signing keys in VMs that
    need them.
  * debian/control: add genisoimage, qemu-utils, qemu-system-x86, python3 to
    Build-Depends for the automatic key enrollment process.
  * debian/rules:
    - build a SecureBoot/SMM enabled variant of OVMF_CODE too.
    - build OVMF_VARS.ms.fd with embedded Microsoft keys from the binary
      EnrollDefaultKeys.efi
  * debian/ovmf.links: add OVMF_CODE.ms.fd.
  * debian/ovmf.install: install OVMF_VARS.ms.fd.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 08 Jun 2018 15:36:47 -0700

edk2 (0~20180503.ebafede9-1) unstable; urgency=medium

  * New upstream release.

 -- dann frazier <dannf@debian.org>  Thu, 03 May 2018 17:00:35 -0600

edk2 (0~20180328.c27c0003-1) unstable; urgency=medium

  * New upstream release.
  * Bump openssl up to latest upstream version, 1.1.0h.

 -- dann frazier <dannf@debian.org>  Wed, 28 Mar 2018 11:06:08 -0600

=== debian/control ===
Source: edk2
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>, Serge Hallyn <serge.hallyn@ubuntu.com>, dann frazier <dannf@debian.org>
Build-Depends: debhelper (>= 10), uuid-dev, iasl, gcc-multilib [i386], nasm, python, gcc-aarch64-linux-gnu, gcc-arm-linux-gnueabihf, genisoimage, qemu-utils, qemu-system-x86, python3
Standards-Version: 4.1.3
Homepage: http://www.tianocore.org
Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git
Vcs-Browser: https://salsa.debian.org/qemu-team/edk2
XS-Build-Indep-Architecture: amd64

Package: ovmf
Architecture: all
Depends: ${misc:Depends}
Replaces: qemu-system-common (<<1.7.0+dfsg-3ubuntu4)
Description: UEFI firmware for 64-bit x86 virtual machines
 Open Virtual Machine Firmware is a build of EDK II for 64-bit x86 virtual
 machines. It includes full support for UEFI, including Secure Boot, allowing
 use of UEFI in place of a traditional BIOS in your VM.

Package: qemu-efi-arm
Architecture: all
Depends: ${misc:Depends}
Description: UEFI firmware for 32-bit ARM virtual machines
 qemu-efi-arm is a build of EDK II for 32-bit ARM virtual machines. It
 includes full support for UEFI, including Secure Boot.

Package: qemu-efi-aarch64
Architecture: all
Depends: ${misc:Depends}
Breaks: qemu-efi (<< 0~20161202.7bbe0b3e-2)
Description: UEFI firmware for 64-bit ARM virtual machines
 qemu-efi-aarch64 is a build of EDK II for 64-bit ARM virtual machines. It
 includes full support for UEFI, including Secure Boot.

Package: qemu-efi
Architecture: all
Depends: qemu-efi-aarch64, ${misc:Depends}
Description: transitional dummy package
 This is a transitional dummy package. It contains a compatibility symlink
 of /usr/share/qemu-efi/QEMU_EFI.fd to /usr/share/qemu-efi-aarch64/QEMU_EFI.fd.

=== debian/rules ===
#!/usr/bin/make -f

SHELL=/bin/bash

# various bits that have to be pulled in to create the full source tarball
OPENSSL_VER= 1.1.0h
OPENSSL_SRC= openssl-$(OPENSSL_VER).tar.gz
OPENSSL_URL= http://www.openssl.org/source/$(OPENSSL_SRC)
SHELL_SRC  = https://svn.code.sf.net/p/efi-shell/code/trunk/Shell
SHELL_REV  = 64


# Only used for creating our build tools.
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# Bumping this up to >= GCC5 will require the replacing the pre-compiled
# liblto*.a binaries that we strip from our orig.tar.xz.
EDK2_TOOLCHAIN = GCC49
export $(EDK2_TOOLCHAIN)_AARCH64_PREFIX=aarch64-linux-gnu-
export $(EDK2_TOOLCHAIN)_ARM_PREFIX=arm-linux-gnueabihf-

ifeq ($(DEB_BUILD_ARCH),amd64)
	EDK2_BUILD_ARCH=X64
endif
ifeq ($(DEB_BUILD_ARCH),i386)
	EDK2_BUILD_ARCH=IA32
endif
ifeq ($(DEB_BUILD_ARCH),arm64)
	EDK2_BUILD_ARCH=AARCH64
endif

ifeq ($(DEB_HOST_ARCH),amd64)
	EDK2_HOST_ARCH=X64
endif
ifeq ($(DEB_HOST_ARCH),i386)
	EDK2_HOST_ARCH=IA32
endif

# Clear variables used internally by the edk2 build system
undefine WORKSPACE
undefine ECP_SOURCE
undefine EDK_SOURCE
undefine EFI_SOURCE
undefine EDK_TOOLS_PATH
undefine CONF_PATH

ver := $(shell dpkg-parsechangelog | sed -n -e's/^Version: \(.*\)-[^-]\+/\1/p')

%:
	dh $@

override_dh_auto_build: build-qemu-efi-aarch64 build-qemu-efi-arm build-ovmf

setup-build:
	make -C BaseTools ARCH=$(EDK2_BUILD_ARCH)
	# We call this twice because it modifies the shell environment,
	# and it's excessively awkward to do all the subsequent work in a
	# single shell invocation
	. ./edksetup.sh

build-ovmf: EDK2_ARCH_DIR=X64
build-ovmf: EDK2_HOST_ARCH=X64
build-ovmf: setup-build
ifneq (,$(findstring ovmf, $(shell dh_listpackages)))
	cd UefiCpuPkg/ResetVector/Vtf0 && python Build.py
	mkdir -p EdkShellBinPkg/FullShell/$(EDK2_ARCH_DIR) \
	         FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)
	mkdir ovmf/
	set -e; . ./edksetup.sh; \
		build -a $(EDK2_HOST_ARCH) -p EdkShellPkg/EdkShellPkg.dsc -m Shell/ShellFull.inf \
			-b RELEASE -t $(EDK2_TOOLCHAIN); \
		cp -a Build/EdkShellPkg/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_ARCH_DIR)/ShellFull.efi \
			EdkShellBinPkg/FullShell/$(EDK2_ARCH_DIR)/Shell_Full.efi; \
		build -a $(EDK2_HOST_ARCH) -p FatPkg/FatPkg.dsc -m FatPkg/EnhancedFatDxe/Fat.inf \
			-b RELEASE -t $(EDK2_TOOLCHAIN); \
		cp -a Build/Fat/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_ARCH_DIR)/Fat.efi \
			FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)/Fat.efi; \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			-DHTTP_BOOT_ENABLE=TRUE \
			-DSECURE_BOOT_ENABLE=TRUE \
			-DFD_SIZE_2MB \
			-b RELEASE; \
		cp Build/Ovmf$(EDK2_HOST_ARCH)/*/FV/OVMF_*.fd ovmf/; \
		rm -rf Build/Ovmf$(EDK2_HOST_ARCH); \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p OvmfPkg/OvmfPkgX64.dsc \
			-DHTTP_BOOT_ENABLE=TRUE \
			-DSECURE_BOOT_ENABLE=TRUE \
			-DSMM_REQUIRE=TRUE \
			-DFD_SIZE_2MB \
			-b RELEASE; \
		cp Build/Ovmf$(EDK2_HOST_ARCH)/*/FV/OVMF_CODE.fd ovmf/OVMF_CODE.secboot.fd
	cp Build/Ovmf$(EDK2_HOST_ARCH)/RELEASE_*GCC*/$(EDK2_ARCH_DIR)/EnrollDefaultKeys.efi ovmf/
	cp Build/Ovmf$(EDK2_HOST_ARCH)/RELEASE_*GCC*/$(EDK2_ARCH_DIR)/Shell.efi ovmf/
	debian/build-iso.sh ovmf/
	python3 debian/ovmf-vars-generator --qemu-binary /usr/bin/qemu-system-x86_64 \
		--disable-smm \
		--skip-testing \
		--ovmf-binary ovmf/OVMF_CODE.fd \
		--ovmf-template-vars ovmf/OVMF_VARS.fd \
		--uefi-shell-iso ovmf/UefiShell.iso \
		ovmf/OVMF_VARS.ms.fd
endif

build-qemu-efi: setup-build
	mkdir -p ShellBinPkg/UefiShell/$(EDK2_ARCH_DIR) FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)
	set -e; . ./edksetup.sh; \
		build -a $(EDK2_HOST_ARCH) -p ShellPkg/ShellPkg.dsc \
			-b RELEASE -t $(EDK2_TOOLCHAIN); \
		cp -a Build/Shell/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_HOST_ARCH)/Shell.efi \
			ShellBinPkg/UefiShell/$(EDK2_ARCH_DIR)/Shell.efi; \
		build -a $(EDK2_HOST_ARCH) -p FatPkg/FatPkg.dsc \
			-m FatPkg/EnhancedFatDxe/Fat.inf \
			-t $(EDK2_TOOLCHAIN) -b RELEASE; \
		cp -a Build/Fat/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_HOST_ARCH)/Fat.efi \
			FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)/Fat.efi; \
		build -a $(EDK2_HOST_ARCH) \
			-t $(EDK2_TOOLCHAIN) \
			-p ArmVirtPkg/ArmVirtQemu.dsc \
			-DHTTP_BOOT_ENABLE=TRUE \
			-DSECURE_BOOT_ENABLE=TRUE \
			-DINTEL_BDS \
			-b RELEASE
	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd bs=1M seek=64 count=0
	dd if=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/QEMU_EFI.fd of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd conv=notrunc
	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_VARS.fd bs=1M seek=64 count=0

build-qemu-efi-aarch64:
	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=AArch64 EDK2_HOST_ARCH=AARCH64 FW_NAME=AAVMF

build-qemu-efi-arm:
	$(MAKE) -f debian/rules build-qemu-efi EDK2_ARCH_DIR=Arm EDK2_HOST_ARCH=ARM FW_NAME=AAVMF32

override_dh_auto_clean:
	set -e; \
	if [ -d BaseTools/Source/C/bin ]; then \
		. ./edksetup.sh; build clean; \
		make -C BaseTools clean; \
	fi
	rm -rf Conf/.cache Build .pc-post

get-orig-source:
	# Should be executed on a checkout of the upstream master branch,
	# with the debian/ directory manually copied in.
	git clone . edk2-$(ver)
	rm -rf edk2-$(ver)/.git
	ln -s ../debian edk2-$(ver)
	# Remove known-binary files
	cd edk2-$(ver) && python3 ./debian/remove-binaries.py
	# Look for possible unknown binary files
	cd edk2-$(ver) && python3 ./debian/find-binaries.py
	rm edk2-$(ver)/debian
	# openssl
	wget $(OPENSSL_URL)
	tar zxvf $(OPENSSL_SRC) -C edk2-$(ver)/CryptoPkg/Library/OpensslLib
	rm -rf edk2-$(ver)/CryptoPkg/Library/OpensslLib/openssl && \
		ln -s openssl-$(OPENSSL_VER) \
		edk2-$(ver)/CryptoPkg/Library/OpensslLib/openssl
	# efi shell
	svn export -r$(SHELL_REV) $(SHELL_SRC) edk2-$(ver)/Shell
	cd edk2-$(ver)/Shell && patch -p1 < ../EdkShellPkg/ShellR$(SHELL_REV).patch 
	tar Jcvf ../edk2_$(ver).orig.tar.xz edk2-$(ver)
	rm -rf edk2-$(ver) $(OPENSSL_SRC)

.PHONY: setup-build build-ovmf build-qemu-efi

## edk2 0~20181115.85588389

=== BaseTools/Makefile ===
## @file
# Windows makefile for Base Tools project build.
#
# Copyright (c) 2007 - 2018, Intel Corporation. All rights reserved.<BR>
# This program and the accompanying materials
# are licensed and made available under the terms and conditions of the BSD License
# which accompanies this distribution.  The full text of the license may be found at
# http://opensource.org/licenses/bsd-license.php
#
# THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
# WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
#

!IFNDEF BASE_TOOLS_PATH
!ERROR "BASE_TOOLS_PATH is not set! Please run toolsetup.bat first!"
!ENDIF

SUBDIRS = $(BASE_TOOLS_PATH)\Source\C $(BASE_TOOLS_PATH)\Source\Python

all: c

c :
  @$(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $(BASE_TOOLS_PATH)\Source\C


subdirs: $(SUBDIRS)
  @$(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $**

.PHONY: clean
clean:
  $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py clean $(SUBDIRS)

.PHONY: cleanall
cleanall:
  $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  cleanall $(SUBDIRS)

=== BaseTools/Source/C/Makefile ===
## @file
# Windows makefile for C tools build.
#
# Copyright (c) 2009 - 2018, Intel Corporation. All rights reserved.<BR>
# This program and the accompanying materials
# are licensed and made available under the terms and conditions of the BSD License
# which accompanies this distribution.  The full text of the license may be found at
# http://opensource.org/licenses/bsd-license.php
#
# THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
# WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
#
HOST_ARCH = IA32

!INCLUDE Makefiles\ms.common

LIBRARIES = Common
APPLICATIONS = \
  VfrCompile \
  BrotliCompress \
  EfiLdrImage \
  EfiRom \
  GenBootSector \
  GenCrc32 \
  GenFfs \
  GenFv \
  GenFw \
  GenPage \
  GenSec \
  GenVtf \
  LzmaCompress \
  Split \
  TianoCompress \
  VolInfo \
  BootSectImage \
  DevicePath

all: libs apps install

libs: $(LIBRARIES)
	@echo.
	@echo ######################
	@echo # Build libraries
	@echo ######################
	@if not exist $(LIB_PATH) mkdir $(LIB_PATH)
	@$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py all $**

apps: $(APPLICATIONS)
	@echo.
	@echo ######################
	@echo # Build executables
	@echo ######################
	@if not exist $(BIN_PATH) mkdir $(BIN_PATH)
	@$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py all $**

install: $(LIB_PATH) $(BIN_PATH)
	@echo.
	@echo ######################
	@echo # Install to $(SYS_LIB_PATH)
	@echo # Install to $(SYS_BIN_PATH)
	@echo ######################
	@-xcopy $(LIB_PATH)\*.lib $(SYS_LIB_PATH) /I /D /E /F /Y > NUL 2>&1
	@-xcopy $(BIN_PATH)\*.exe $(SYS_BIN_PATH) /I /D /E /F /Y > NUL 2>&1
  @-xcopy $(BIN_PATH)\*.bat $(SYS_BIN_PATH) /I /D /E /F /Y > NUL 2>&1

.PHONY: clean
clean:
  @$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py clean $(LIBRARIES) $(APPLICATIONS)

.PHONY: cleanall
cleanall:
  @$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py cleanall $(LIBRARIES) $(APPLICATIONS)

!INCLUDE Makefiles\ms.rule

=== BaseTools/Source/Python/Makefile ===
## @file
# Windows makefile for Python tools build.
#
# Copyright (c) 2010 - 2018, Intel Corporation. All rights reserved.<BR>
# This program and the accompanying materials
# are licensed and made available under the terms and conditions of the BSD License
# which accompanies this distribution.  The full text of the license may be found at
# http://opensource.org/licenses/bsd-license.php
#
# THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
# WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
#

all:

clean:
cleanall:  
  @del /f /q $(BASE_TOOLS_PATH)\Source\Python\*.pyc

=== BaseTools/Source/C/BrotliCompress/Makefile ===
## @file
# Windows makefile for 'Brotli' module build.
#
# Copyright (c) 2017 - 2018, Intel Corporation. All rights reserved.<BR>
# This program and the accompanying materials
# are licensed and made available under the terms and conditions of the BSD License
# which accompanies this distribution.  The full text of the license may be found at
# http://opensource.org/licenses/bsd-license.php
#
# THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
# WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
#
!INCLUDE ..\Makefiles\ms.common

INC = -I .\include $(INC)
CFLAGS = $(CFLAGS) /W2

APPNAME = Brotli

#LIBS = $(LIB_PATH)\Common.lib

COMMON_OBJ = common\dictionary.obj common\transform.obj
DEC_OBJ = \
  dec\bit_reader.obj \
  dec\decode.obj \
  dec\huffman.obj \
  dec\state.obj
ENC_OBJ = \
  enc\backward_references.obj \
  enc\backward_references_hq.obj \
  enc\bit_cost.obj \
  enc\block_splitter.obj \
  enc\brotli_bit_stream.obj \
  enc\cluster.obj \
  enc\compress_fragment.obj \
  enc\compress_fragment_two_pass.obj \
  enc\dictionary_hash.obj \
  enc\encode.obj \
  enc\encoder_dict.obj \
  enc\entropy_encode.obj \
  enc\histogram.obj \
  enc\literal_cost.obj \
  enc\memory.obj \
  enc\metablock.obj \
  enc\static_dict.obj \
  enc\utf8_util.obj

OBJECTS = \
  tools\brotli.obj \
  $(COMMON_OBJ) \
  $(DEC_OBJ) \
  $(ENC_OBJ)

!INCLUDE ..\Makefiles\ms.app

=== debian/changelog ===
edk2 (0~20181115.85588389-3+deb10u4) buster-security; urgency=high

  * Non-maintainer upload by the LTS team.
  * Disable the built-in Shell when SecureBoot is enabled, CVE-2023-48733.
    Thanks to Mate Kukri. LP: #2040137.
    - Backport support for GetSetupMode() and IsSecureBootEnabled():
      + 0001-SecurityPkg-Create-SecureBootVariableLib.patch
      + 0002-ArmVirtPkg-add-SecureBootVariableLib-class-resolutio.patch
      + 0003-OvmfPkg-add-SecureBootVariableLib-class-resolution.patch
      + 0004-SecurityPkg-SecureBootVariableLib-Added-newly-suppor.patch
      + 0005-EmulatorPkg-add-SecureBootVariableLib-class-resoluti.patch
    - Disable the built-in Shell when SecureBoot is enabled:
      + Disable-the-Shell-when-SecureBoot-is-enabled.patch
    - d/tests: Drop the boot-to-shell tests for images w/ Secure Boot active.

 -- Markus Koschany <apo@debian.org>  Sun, 30 Jun 2024 21:33:14 +0200

edk2 (0~20181115.85588389-3+deb10u3) buster; urgency=medium

  * CryptoPkg/BaseCryptLib: fix NULL dereference. (CVE-2019-14584)
    (Closes: #977300)
     - d/p/CryptoPkg-BaseCryptLib-fix-NULL-dereference-CVE-2019.patch

 -- dann frazier <dannf@debian.org>  Tue, 15 Dec 2020 12:30:28 -0700

edk2 (0~20181115.85588389-3+deb10u2) buster; urgency=medium

  * Fix integer overflow in DxeImageVerificationHandler. (CVE-2019-14562)
    (Closes: #968819)
     - d/p/0001-SecurityPkg-DxeImageVerificationLib-extract-SecDataD.patch
     - d/p/0002-SecurityPkg-DxeImageVerificationLib-assign-WinCertif.patch
     - d/p/0003-SecurityPkg-DxeImageVerificationLib-catch-alignment-.patch

 -- dann frazier <dannf@debian.org>  Thu, 17 Sep 2020 13:45:52 -0600

edk2 (0~20181115.85588389-3+deb10u1) buster; urgency=medium

  * Fix numeric truncation in S3BootScript[Save]*() API. (CVE-2019-14563)
  * Fix use-after-free in PcdHiiOsRuntimeSupport. (CVE-2019-14586)
  * Clear memory before free to avoid potential password leak.
    (CVE-2019-14558)
  * Fix double-unmap in SdMmcCreateTrb(). This did not impact any
    of the images built from this package. (CVE-2019-14587)
  * Fix memory leak in ArpOnFrameRcvdDpc(). (CVE-2019-14559)
  * Fix issue that could allow an efi image with a blacklisted hash in the
    dbx to be loaded. (CVE-2019-14575) (Closes: 952935)
  * Fix a memory leak in the ARP handler. (CVE-2019-14559) (Closes: #952926)

 -- dann frazier <dannf@debian.org>  Thu, 23 Apr 2020 13:33:06 -0600

edk2 (0~20181115.85588389-3) unstable; urgency=medium

  * Security fixes (Closes: #924615):
    - Fix buffer overflow in BlockIo service (CVE-2018-12180)
    - DNS: Check received packet size before using (CVE-2018-12178)
    - Fix stack overflow with corrupted BMP (CVE-2018-12181)

 -- dann frazier <dannf@debian.org>  Fri, 15 Mar 2019 18:37:44 -0600

edk2 (0~20181115.85588389-2) unstable; urgency=medium

  * debian/rules: Factor out common feature flags across builds.
  * ovmf: Enable TPM2 device support. Closes: #914722.

 -- dann frazier <dannf@debian.org>  Mon, 26 Nov 2018 16:34:54 -0700

edk2 (0~20181115.85588389-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable201811 tag.

 -- dann frazier <dannf@debian.org>  Thu, 15 Nov 2018 11:28:06 -0700

edk2 (0~20180812.cb5f4f45-1) unstable; urgency=medium

  * New upstream release, based on edk2-stable201808 tag.

 -- dann frazier <dannf@debian.org>  Thu, 06 Sep 2018 16:12:41 -0600

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: edk2
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>, Serge Hallyn <serge.hallyn@ubuntu.com>, dann frazier <dannf@debian.org>
-Build-Depends: debhelper (>= 10), uuid-dev, iasl, gcc-multilib [i386], nasm, python, gcc-aarch64-linux-gnu, gcc-arm-linux-gnueabihf, genisoimage, qemu-utils, qemu-system-x86, python3
+Build-Depends: debhelper (>= 10), uuid-dev, iasl, gcc-multilib [i386], nasm, python, gcc-aarch64-linux-gnu, gcc-arm-linux-gnueabihf
 Standards-Version: 4.1.3
 Homepage: http://www.tianocore.org
 Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git

=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,10 @@
 	EDK2_HOST_ARCH=IA32
 endif
 
+COMMON_FLAGS = -DHTTP_BOOT_ENABLE=TRUE -DSECURE_BOOT_ENABLE=TRUE
+OVMF_FLAGS   = $(COMMON_FLAGS) -DFD_SIZE_2MB -DTPM2_ENABLE=TRUE
+AAVMF_FLAGS  = $(COMMON_FLAGS) -DINTEL_BDS
+
 # Clear variables used internally by the edk2 build system
 undefine WORKSPACE
 undefine ECP_SOURCE
@@ -67,7 +71,6 @@
 	cd UefiCpuPkg/ResetVector/Vtf0 && python Build.py
 	mkdir -p EdkShellBinPkg/FullShell/$(EDK2_ARCH_DIR) \
 	         FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)
-	mkdir ovmf/
 	set -e; . ./edksetup.sh; \
 		build -a $(EDK2_HOST_ARCH) -p EdkShellPkg/EdkShellPkg.dsc -m Shell/ShellFull.inf \
 			-b RELEASE -t $(EDK2_TOOLCHAIN); \
@@ -80,31 +83,7 @@
 		build -a $(EDK2_HOST_ARCH) \
 			-t $(EDK2_TOOLCHAIN) \
 			-p OvmfPkg/OvmfPkgX64.dsc \
-			-DHTTP_BOOT_ENABLE=TRUE \
-			-DSECURE_BOOT_ENABLE=TRUE \
-			-DFD_SIZE_2MB \
-			-b RELEASE; \
-		cp Build/Ovmf$(EDK2_HOST_ARCH)/*/FV/OVMF_*.fd ovmf/; \
-		rm -rf Build/Ovmf$(EDK2_HOST_ARCH); \
-		build -a $(EDK2_HOST_ARCH) \
-			-t $(EDK2_TOOLCHAIN) \
-			-p OvmfPkg/OvmfPkgX64.dsc \
-			-DHTTP_BOOT_ENABLE=TRUE \
-			-DSECURE_BOOT_ENABLE=TRUE \
-			-DSMM_REQUIRE=TRUE \
-			-DFD_SIZE_2MB \
-			-b RELEASE; \
-		cp Build/Ovmf$(EDK2_HOST_ARCH)/*/FV/OVMF_CODE.fd ovmf/OVMF_CODE.secboot.fd
-	cp Build/Ovmf$(EDK2_HOST_ARCH)/RELEASE_*GCC*/$(EDK2_ARCH_DIR)/EnrollDefaultKeys.efi ovmf/
-	cp Build/Ovmf$(EDK2_HOST_ARCH)/RELEASE_*GCC*/$(EDK2_ARCH_DIR)/Shell.efi ovmf/
-	debian/build-iso.sh ovmf/
-	python3 debian/ovmf-vars-generator --qemu-binary /usr/bin/qemu-system-x86_64 \
-		--disable-smm \
-		--skip-testing \
-		--ovmf-binary ovmf/OVMF_CODE.fd \
-		--ovmf-template-vars ovmf/OVMF_VARS.fd \
-		--uefi-shell-iso ovmf/UefiShell.iso \
-		ovmf/OVMF_VARS.ms.fd
+			$(OVMF_FLAGS) -b RELEASE
 endif
 
 build-qemu-efi: setup-build
@@ -122,10 +101,7 @@
 		build -a $(EDK2_HOST_ARCH) \
 			-t $(EDK2_TOOLCHAIN) \
 			-p ArmVirtPkg/ArmVirtQemu.dsc \
-			-DHTTP_BOOT_ENABLE=TRUE \
-			-DSECURE_BOOT_ENABLE=TRUE \
-			-DINTEL_BDS \
-			-b RELEASE
+			$(AAVMF_FLAGS) -b RELEASE
 	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd bs=1M seek=64 count=0
 	dd if=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/QEMU_EFI.fd of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_CODE.fd conv=notrunc
 	dd if=/dev/zero of=Build/ArmVirtQemu-$(EDK2_HOST_ARCH)/RELEASE_$(EDK2_TOOLCHAIN)/FV/$(FW_NAME)_VARS.fd bs=1M seek=64 count=0

## edk2 0~20181115.85588389.1

=== debian/changelog ===
edk2 (0~20181115.85588389.1-1+eagle) unstable; urgency=medium

  * update

 -- Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>  Tue, 02 Feb 2021 17:30:55 +0800

## edk2 0~20190309.89910a39

=== BaseTools/Makefile ===
--- 
+++ 
@@ -20,17 +20,21 @@
 all: c
 
 c :
-  @$(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $(BASE_TOOLS_PATH)\Source\C
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $(BASE_TOOLS_PATH)\Source\C
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $(BASE_TOOLS_PATH)\Source\C
 
 
 subdirs: $(SUBDIRS)
-  @$(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $**
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $**
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  all $**
 
 .PHONY: clean
 clean:
-  $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py clean $(SUBDIRS)
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py clean $(SUBDIRS)
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py clean $(SUBDIRS)
 
 .PHONY: cleanall
 cleanall:
-  $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  cleanall $(SUBDIRS)
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  cleanall $(SUBDIRS)
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe $(BASE_TOOLS_PATH)\Source\C\Makefiles\NmakeSubdirs.py  cleanall $(SUBDIRS)

=== BaseTools/Source/C/Makefile ===
--- 
+++ 
@@ -18,21 +18,16 @@
 APPLICATIONS = \
   VfrCompile \
   BrotliCompress \
-  EfiLdrImage \
   EfiRom \
-  GenBootSector \
   GenCrc32 \
   GenFfs \
   GenFv \
   GenFw \
-  GenPage \
   GenSec \
-  GenVtf \
   LzmaCompress \
   Split \
   TianoCompress \
   VolInfo \
-  BootSectImage \
   DevicePath
 
 all: libs apps install
@@ -43,7 +38,8 @@
 	@echo # Build libraries
 	@echo ######################
 	@if not exist $(LIB_PATH) mkdir $(LIB_PATH)
-	@$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py all $**
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) Makefiles\NmakeSubdirs.py all $**
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py all $**
 
 apps: $(APPLICATIONS)
 	@echo.
@@ -51,7 +47,8 @@
 	@echo # Build executables
 	@echo ######################
 	@if not exist $(BIN_PATH) mkdir $(BIN_PATH)
-	@$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py all $**
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) Makefiles\NmakeSubdirs.py all $**
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py all $**
 
 install: $(LIB_PATH) $(BIN_PATH)
 	@echo.
@@ -65,11 +62,13 @@
 
 .PHONY: clean
 clean:
-  @$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py clean $(LIBRARIES) $(APPLICATIONS)
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) Makefiles\NmakeSubdirs.py clean $(LIBRARIES) $(APPLICATIONS)
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py clean $(LIBRARIES) $(APPLICATIONS)
 
 .PHONY: cleanall
 cleanall:
-  @$(PYTHON_HOME)\python.exe Makefiles\NmakeSubdirs.py cleanall $(LIBRARIES) $(APPLICATIONS)
+  @if defined PYTHON_COMMAND $(PYTHON_COMMAND) $(PYTHON_COMMAND) Makefiles\NmakeSubdirs.py cleanall $(LIBRARIES) $(APPLICATIONS)
+  @if not defined PYTHON_COMMAND $(PYTHON_HOME)\python.exe $(PYTHON_COMMAND) Makefiles\NmakeSubdirs.py cleanall $(LIBRARIES) $(APPLICATIONS)
 
 !INCLUDE Makefiles\ms.rule

=== debian/changelog ===
edk2 (0~20190309.89910a39-1ubuntu1) disco; urgency=medium

  * Merge with Debian experimental. Remaining changes:
    - debian/patches/enroll-default-keys.patch: Build EnrollDefaultKeys.efi to
      provide an automated way of injecting Microsoft signing keys in VMs that
      need them.
    - debian/control: add genisoimage, qemu-utils, qemu-system-x86, python3 to
      Build-Depends for the automatic key enrollment process.
    - debian/rules:
      - build a SecureBoot/SMM enabled variant of OVMF_CODE too.
      - build OVMF_VARS.ms.fd with embedded Microsoft keys from the binary
        EnrollDefaultKeys.efi
    - debian/ovmf.links: add OVMF_CODE.ms.fd.
    - debian/ovmf.install: install OVMF_VARS.ms.fd.
  * debian/control: Fold and sort Build-Depends line.
  * debian/control: Add bc to Build-Depends, as it is now used by
    edksetup.sh.
  * debian/control: Add python3-distutils to Build-Depends. Part of
    the build will now use python3 instead of python if found at build-time.
    However, the build requires distutils, and upstream only embeds the
    python(2) version of that.

 -- dann frazier <dann.frazier@canonical.com>  Mon, 18 Mar 2019 21:44:41 -0600

edk2 (0~20190309.89910a39-1) experimental; urgency=medium

  * New upstream release, based on edk2-stable201903 tag.
    - Fixes for CVE-2018-12178, CVE-2018-12180 and CVE-2018-12181
      Closes: #924615.
    - qemu-efi-*: Avoid silent corruption of firmware flash image
      by buggy EFI apps. Closes: #924620, LP: #1812093.
    - d/binary-check.blacklist: Drop binaries removed upstream.
    - d/binary-check.whitelist: Add new files detected as binary
      that were hand-verified to be source.
    - Bump openssl up to 1.1.0j.
    - qemu-efi-{arm,aarch64}: Drop -DINTEL_BDS from build flags.
      It became the default some time ago and was removed.
    - ovmf: Stop cargo-culting the inclusion and build of external
      EdkShell source. This is now no longer supported by upstream,
      and is a no-op because it was replaced by the internal UEFI
      shell back 2013 (9bef3cdc "OvmfPkg: Build and use the UEFI shell
      by default").
    - qemu-efi-{arm,aarch64}: Don't explicitly build ShellPkg,
      ArmVirtPkg has been doing it since 2015 (da1ce6f8
      "ArmVirtualizationPkg: build UEFI shell from source").
    - Don't explicitly build FatPkg, OvmfPkg & ArmVirtPkg have
      included it since 2016 (aa47e529 "OvmfPkg: Convert to using
      FatPkg in the EDK II tree"), (42e3d9eb "ArmVirtPkg: Convert to
      build FatPkg from source").
    - d/p/no-missing-braces.diff: Forward port.
    - d/p/no-stack-protector-all-archs.diff: Forward port.

 -- dann frazier <dannf@debian.org>  Mon, 18 Mar 2019 15:38:21 -0600

edk2 (0~20181115.85588389-3ubuntu1) disco; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - debian/patches/enroll-default-keys.patch: Build EnrollDefaultKeys.efi to
      provide an automated way of injecting Microsoft signing keys in VMs that
      need them.
    - debian/control: add genisoimage, qemu-utils, qemu-system-x86, python3 to
      Build-Depends for the automatic key enrollment process.
    - debian/rules:
      - build a SecureBoot/SMM enabled variant of OVMF_CODE too.
      - build OVMF_VARS.ms.fd with embedded Microsoft keys from the binary
        EnrollDefaultKeys.efi
    - debian/ovmf.links: add OVMF_CODE.ms.fd.
    - debian/ovmf.install: install OVMF_VARS.ms.fd.

 -- dann frazier <dannf@ubuntu.com>  Fri, 15 Mar 2019 19:40:03 -0600

edk2 (0~20181115.85588389-1ubuntu1) disco; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - debian/patches/enroll-default-keys.patch: Build EnrollDefaultKeys.efi to
      provide an automated way of injecting Microsoft signing keys in VMs that
      need them.
    - debian/control: add genisoimage, qemu-utils, qemu-system-x86, python3 to
      Build-Depends for the automatic key enrollment process.
    - debian/rules:
      - build a SecureBoot/SMM enabled variant of OVMF_CODE too.
      - build OVMF_VARS.ms.fd with embedded Microsoft keys from the binary
        EnrollDefaultKeys.efi
    - debian/ovmf.links: add OVMF_CODE.ms.fd.
    - debian/ovmf.install: install OVMF_VARS.ms.fd.

 -- dann frazier <dannf@ubuntu.com>  Thu, 15 Nov 2018 13:58:08 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,23 @@
 Source: edk2
 Section: misc
 Priority: optional
-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>, Serge Hallyn <serge.hallyn@ubuntu.com>, dann frazier <dannf@debian.org>
-Build-Depends: debhelper (>= 10), uuid-dev, iasl, gcc-multilib [i386], nasm, python, gcc-aarch64-linux-gnu, gcc-arm-linux-gnueabihf
+Build-Depends: bc,
+ debhelper (>= 10),
+ gcc-aarch64-linux-gnu,
+ gcc-arm-linux-gnueabihf,
+ gcc-multilib [i386],
+ genisoimage,
+ iasl,
+ nasm,
+ python,
+ python3,
+ python3-distutils,
+ qemu-utils,
+ qemu-system-x86,
+ uuid-dev,
 Standards-Version: 4.1.3
 Homepage: http://www.tianocore.org
 Vcs-Git: https://salsa.debian.org/qemu-team/edk2.git

=== debian/rules ===
--- 
+++ 
@@ -3,12 +3,9 @@
 SHELL=/bin/bash
 
 # various bits that have to be pulled in to create the full source tarball
-OPENSSL_VER= 1.1.0h
+OPENSSL_VER= 1.1.0j
 OPENSSL_SRC= openssl-$(OPENSSL_VER).tar.gz
 OPENSSL_URL= http://www.openssl.org/source/$(OPENSSL_SRC)
-SHELL_SRC  = https://svn.code.sf.net/p/efi-shell/code/trunk/Shell
-SHELL_REV  = 64
-
 
 # Only used for creating our build tools.
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
@@ -40,7 +37,8 @@
 
 COMMON_FLAGS = -DHTTP_BOOT_ENABLE=TRUE -DSECURE_BOOT_ENABLE=TRUE
 OVMF_FLAGS   = $(COMMON_FLAGS) -DFD_SIZE_2MB -DTPM2_ENABLE=TRUE
-AAVMF_FLAGS  = $(COMMON_FLAGS) -DINTEL_BDS
+OVMF_SB_FLAGS = $(OVMF_FLAGS) -DSMM_REQUIRE=TRUE
+AAVMF_FLAGS  = $(COMMON_FLAGS)
 
 # Clear variables used internally by the edk2 build system
 undefine WORKSPACE
@@ -69,35 +67,33 @@
 build-ovmf: setup-build
 ifneq (,$(findstring ovmf, $(shell dh_listpackages)))
 	cd UefiCpuPkg/ResetVector/Vtf0 && python Build.py
-	mkdir -p EdkShellBinPkg/FullShell/$(EDK2_ARCH_DIR) \
-	         FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)
+	mkdir ovmf/
 	set -e; . ./edksetup.sh; \
-		build -a $(EDK2_HOST_ARCH) -p EdkShellPkg/EdkShellPkg.dsc -m Shell/ShellFull.inf \
-			-b RELEASE -t $(EDK2_TOOLCHAIN); \
-		cp -a Build/EdkShellPkg/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_ARCH_DIR)/ShellFull.efi \
-			EdkShellBinPkg/FullShell/$(EDK2_ARCH_DIR)/Shell_Full.efi; \
-		build -a $(EDK2_HOST_ARCH) -p FatPkg/FatPkg.dsc -m FatPkg/EnhancedFatDxe/Fat.inf \
-			-b RELEASE -t $(EDK2_TOOLCHAIN); \
-		cp -a Build/Fat/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_ARCH_DIR)/Fat.efi \
-			FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)/Fat.efi; \
 		build -a $(EDK2_HOST_ARCH) \
 			-t $(EDK2_TOOLCHAIN) \
 			-p OvmfPkg/OvmfPkgX64.dsc \
-			$(OVMF_FLAGS) -b RELEASE
+			$(OVMF_FLAGS) -b RELEASE; \
+		cp Build/Ovmf$(EDK2_HOST_ARCH)/*/FV/OVMF_*.fd ovmf/; \
+		rm -rf Build/Ovmf$(EDK2_HOST_ARCH); \
+		build -a $(EDK2_HOST_ARCH) \
+			-t $(EDK2_TOOLCHAIN) \
+			-p OvmfPkg/OvmfPkgX64.dsc \
+			$(OVMF_SB_FLAGS) -b RELEASE; \
+		cp Build/Ovmf$(EDK2_HOST_ARCH)/*/FV/OVMF_CODE.fd ovmf/OVMF_CODE.secboot.fd
+	cp Build/Ovmf$(EDK2_HOST_ARCH)/RELEASE_*GCC*/$(EDK2_ARCH_DIR)/EnrollDefaultKeys.efi ovmf/
+	cp Build/Ovmf$(EDK2_HOST_ARCH)/RELEASE_*GCC*/$(EDK2_ARCH_DIR)/Shell.efi ovmf/
+	debian/build-iso.sh ovmf/
+	python3 debian/ovmf-vars-generator --qemu-binary /usr/bin/qemu-system-x86_64 \
+		--disable-smm \
+		--skip-testing \
+		--ovmf-binary ovmf/OVMF_CODE.fd \
+		--ovmf-template-vars ovmf/OVMF_VARS.fd \
+		--uefi-shell-iso ovmf/UefiShell.iso \
+		ovmf/OVMF_VARS.ms.fd
 endif
 
 build-qemu-efi: setup-build
-	mkdir -p ShellBinPkg/UefiShell/$(EDK2_ARCH_DIR) FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)
 	set -e; . ./edksetup.sh; \
-		build -a $(EDK2_HOST_ARCH) -p ShellPkg/ShellPkg.dsc \
-			-b RELEASE -t $(EDK2_TOOLCHAIN); \
-		cp -a Build/Shell/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_HOST_ARCH)/Shell.efi \
-			ShellBinPkg/UefiShell/$(EDK2_ARCH_DIR)/Shell.efi; \
-		build -a $(EDK2_HOST_ARCH) -p FatPkg/FatPkg.dsc \
-			-m FatPkg/EnhancedFatDxe/Fat.inf \
-			-t $(EDK2_TOOLCHAIN) -b RELEASE; \
-		cp -a Build/Fat/RELEASE_$(EDK2_TOOLCHAIN)/$(EDK2_HOST_ARCH)/Fat.efi \
-			FatBinPkg/EnhancedFatDxe/$(EDK2_ARCH_DIR)/Fat.efi; \
 		build -a $(EDK2_HOST_ARCH) \
 			-t $(EDK2_TOOLCHAIN) \
 			-p ArmVirtPkg/ArmVirtQemu.dsc \
@@ -137,9 +133,6 @@
 	rm -rf edk2-$(ver)/CryptoPkg/Library/OpensslLib/openssl && \
 		ln -s openssl-$(OPENSSL_VER) \
 		edk2-$(ver)/CryptoPkg/Library/OpensslLib/openssl
-	# efi shell
-	svn export -r$(SHELL_REV) $(SHELL_SRC) edk2-$(ver)/Shell
-	cd edk2-$(ver)/Shell && patch -p1 < ../EdkShellPkg/ShellR$(SHELL_REV).patch 
 	tar Jcvf ../edk2_$(ver).orig.tar.xz edk2-$(ver)
 	rm -rf edk2-$(ver) $(OPENSSL_SRC)
